Index: tags/3.3.5/HeuristicLab 3.3.sln
===================================================================
--- tags/3.3.5/HeuristicLab 3.3.sln	(revision 6560)
+++ tags/3.3.5/HeuristicLab 3.3.sln	(revision 6561)
@@ -38,6 +38,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Persistence-3.3", "HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj", "{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Persistence.GUI-3.3", "HeuristicLab.Persistence.GUI\3.3\HeuristicLab.Persistence.GUI-3.3.csproj", "{A9E282EA-180F-4233-B809-AEDF0787545C}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Core-3.3", "HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj", "{C36BD924-A541-4A00-AFA8-41701378DDC5}"
@@ -168,5 +166,4 @@
 		{34C967E5-EEB1-4502-8035-122EDDEF44CB} = {34C967E5-EEB1-4502-8035-122EDDEF44CB}
 		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0} = {D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}
-		{A9E282EA-180F-4233-B809-AEDF0787545C} = {A9E282EA-180F-4233-B809-AEDF0787545C}
 		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA} = {96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}
 		{5A4679EF-A8F3-4647-B722-441A36B3BA6B} = {5A4679EF-A8F3-4647-B722-441A36B3BA6B}
@@ -445,16 +442,4 @@
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}.Release|x86.ActiveCfg = Release|x86
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}.Release|x86.Build.0 = Release|x86
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|x64.ActiveCfg = Debug|x64
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|x64.Build.0 = Debug|x64
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|x86.ActiveCfg = Debug|x86
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|x86.Build.0 = Debug|x86
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|Any CPU.Build.0 = Release|Any CPU
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|x64.ActiveCfg = Release|x64
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|x64.Build.0 = Release|x64
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|x86.ActiveCfg = Release|x86
-		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|x86.Build.0 = Release|x86
 		{C36BD924-A541-4A00-AFA8-41701378DDC5}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{C36BD924-A541-4A00-AFA8-41701378DDC5}.Debug|Any CPU.Build.0 = Debug|Any CPU
Index: tags/3.3.5/HeuristicLab/3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd
===================================================================
--- tags/3.3.5/HeuristicLab/3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 6560)
+++ tags/3.3.5/HeuristicLab/3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 6561)
@@ -1,3 +1,3 @@
-set target=C:\Program Files\HeuristicLab 3.3
+set target=C:\Program Files\HeuristicLab 3.3.5
 
 copy "HeuristicLab 3.3.exe" "%target%"
Index: tags/3.3.5/HeuristicLab/3.3/Files.txt
===================================================================
--- tags/3.3.5/HeuristicLab/3.3/Files.txt	(revision 6560)
+++ tags/3.3.5/HeuristicLab/3.3/Files.txt	(revision 6561)
@@ -53,5 +53,4 @@
 HeuristicLab.Parameters.Views\3.3:HeuristicLab.Parameters.Views-3.3.dll
 HeuristicLab.Persistence\3.3:HeuristicLab.Persistence-3.3.dll
-HeuristicLab.Persistence.GUI\3.3:HeuristicLab.Persistence.GUI-3.3.dll
 HeuristicLab.Problems.ArtificialAnt\3.3:HeuristicLab.Problems.ArtificialAnt-3.3.dll
 HeuristicLab.Problems.ArtificialAnt\3.4:HeuristicLab.Problems.ArtificialAnt-3.4.dll
Index: tags/3.3.5/HeuristicLab/3.3/Tests/Builder.testsettings
===================================================================
--- tags/3.3.5/HeuristicLab/3.3/Tests/Builder.testsettings	(revision 6560)
+++ tags/3.3.5/HeuristicLab/3.3/Tests/Builder.testsettings	(revision 6561)
@@ -57,5 +57,4 @@
     <DeploymentItem filename="HeuristicLab\3.3\Tests\bin\Release\HeuristicLab.Parameters.Views-3.3.dll" />
     <DeploymentItem filename="HeuristicLab\3.3\Tests\bin\Release\HeuristicLab.Parameters-3.3.dll" />
-    <DeploymentItem filename="HeuristicLab\3.3\Tests\bin\Release\HeuristicLab.Persistence.GUI-3.3.dll" />
     <DeploymentItem filename="HeuristicLab\3.3\Tests\bin\Release\HeuristicLab.Persistence-3.3.dll" />
     <DeploymentItem filename="HeuristicLab\3.3\Tests\bin\Release\HeuristicLab.PluginInfrastructure-3.3.dll" />
Index: tags/3.3.5/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj
===================================================================
--- tags/3.3.5/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 6560)
+++ tags/3.3.5/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 6561)
@@ -370,8 +370,4 @@
       <Name>HeuristicLab.Parameters-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Persistence.GUI\3.3\HeuristicLab.Persistence.GUI-3.3.csproj">
-      <Project>{A9E282EA-180F-4233-B809-AEDF0787545C}</Project>
-      <Name>HeuristicLab.Persistence.GUI-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
       <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>